// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.0.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	openapi_types "github.com/oapi-codegen/runtime/types"
)

// Attribute Moment of registration of a specific attribute of a vreemdeling.
type Attribute struct {
	Attribute string    `json:"attribute"`
	CreatedAt time.Time `json:"createdAt"`

	// Id UUID of attribute.
	Id            AttributeId `json:"id"`
	InvalidatedAt *time.Time  `json:"invalidatedAt,omitempty"`
	Value         interface{} `json:"value"`
}

// AttributeWithObservations merged value of an attribute, including all observations about it.
type AttributeWithObservations struct {
	Observations []Observation `json:"observations"`
	Value        interface{}   `json:"value"`
}

// Error The error that occured while processing this request.
type Error struct {
	Message string `json:"message"`
}

// Observation Moment of registration of a specific observation of a vreemdeling.
type Observation struct {
	Attribute string    `json:"attribute"`
	CreatedAt time.Time `json:"created_at"`

	// Id UUID of observation.
	Id            ObservationId `json:"id"`
	InvalidatedAt *time.Time    `json:"invalidated_at,omitempty"`
	Source        string        `json:"source"`
	Value         interface{}   `json:"value"`
}

// Proces Proces with its attributes
type Proces struct {
	// Attributes An attribute that is attached to a process
	Attributes ProcesAttribute    `json:"attributes"`
	CreatedAt  time.Time          `json:"createdAt"`
	DeletedAt  *time.Time         `json:"deletedAt,omitempty"`
	Id         openapi_types.UUID `json:"id"`
	ProcesId   string             `json:"procesId"`
	Status     string             `json:"status"`
	Type       string             `json:"type"`
}

// ProcesAttribute An attribute that is attached to a process
type ProcesAttribute map[string]struct {
	Attributes []Attribute `json:"attributes"`
	Value      interface{} `json:"value"`
}

// VreemdelingWithObservations A known vreemdeling, with merged attributes and full list of relevant observations.
type VreemdelingWithObservations struct {
	// Id V-number of vreemdeling.
	Id                   VreemdelingId                        `json:"id"`
	AdditionalProperties map[string]AttributeWithObservations `json:"-"`
}

// AttributeId UUID of attribute.
type AttributeId = openapi_types.UUID

// ObservationId UUID of observation.
type ObservationId = openapi_types.UUID

// VreemdelingId V-number of vreemdeling.
type VreemdelingId = string

// PathVreemdelingId V-number of vreemdeling.
type PathVreemdelingId = VreemdelingId

// QueryAttributes defines model for queryAttributes.
type QueryAttributes = []string

// QuerySources defines model for querySources.
type QuerySources = []string

// BadRequestErrorResponse defines model for BadRequestErrorResponse.
type BadRequestErrorResponse struct {
	Errors []Error `json:"errors"`
}

// GoneErrorResponse defines model for GoneErrorResponse.
type GoneErrorResponse struct {
	Errors []Error `json:"errors"`
}

// ProcessenResponse defines model for ProcessenResponse.
type ProcessenResponse struct {
	Data []Proces `json:"data"`
}

// VreemdelingWithObservationsResponse defines model for VreemdelingWithObservationsResponse.
type VreemdelingWithObservationsResponse struct {
	// Data A known vreemdeling, with merged attributes and full list of relevant observations.
	Data VreemdelingWithObservations `json:"data"`
}

// ReadVreemdelingByIdParams defines parameters for ReadVreemdelingById.
type ReadVreemdelingByIdParams struct {
	// Attributes Comma-separated list of attributes to show.
	Attributes QueryAttributes `form:"attributes" json:"attributes"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`
}

// ReadProcessenByVreemdelingIdParams defines parameters for ReadProcessenByVreemdelingId.
type ReadProcessenByVreemdelingIdParams struct {
	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`
}

// Getter for additional properties for VreemdelingWithObservations. Returns the specified
// element and whether it was found
func (a VreemdelingWithObservations) Get(fieldName string) (value AttributeWithObservations, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for VreemdelingWithObservations
func (a *VreemdelingWithObservations) Set(fieldName string, value AttributeWithObservations) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]AttributeWithObservations)
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for VreemdelingWithObservations to handle AdditionalProperties
func (a *VreemdelingWithObservations) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if raw, found := object["id"]; found {
		err = json.Unmarshal(raw, &a.Id)
		if err != nil {
			return fmt.Errorf("error reading 'id': %w", err)
		}
		delete(object, "id")
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]AttributeWithObservations)
		for fieldName, fieldBuf := range object {
			var fieldVal AttributeWithObservations
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return fmt.Errorf("error unmarshaling field %s: %w", fieldName, err)
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for VreemdelingWithObservations to handle AdditionalProperties
func (a VreemdelingWithObservations) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	object["id"], err = json.Marshal(a.Id)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'id': %w", err)
	}

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, fmt.Errorf("error marshaling '%s': %w", fieldName, err)
		}
	}
	return json.Marshal(object)
}

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// ReadVreemdelingById request
	ReadVreemdelingById(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ReadProcessenByVreemdelingId request
	ReadProcessenByVreemdelingId(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) ReadVreemdelingById(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadVreemdelingByIdRequest(c.Server, vreemdelingId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ReadProcessenByVreemdelingId(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadProcessenByVreemdelingIdRequest(c.Server, vreemdelingId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewReadVreemdelingByIdRequest generates requests for ReadVreemdelingById
func NewReadVreemdelingByIdRequest(server string, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, vreemdelingId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/vreemdelingen/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, params.Attributes); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewReadProcessenByVreemdelingIdRequest generates requests for ReadProcessenByVreemdelingId
func NewReadProcessenByVreemdelingIdRequest(server string, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, vreemdelingId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/vreemdelingen/%s/processen", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// ReadVreemdelingByIdWithResponse request
	ReadVreemdelingByIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*ReadVreemdelingByIdResponse, error)

	// ReadProcessenByVreemdelingIdWithResponse request
	ReadProcessenByVreemdelingIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*ReadProcessenByVreemdelingIdResponse, error)
}

type ReadVreemdelingByIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *VreemdelingWithObservationsResponse
	JSON400      *BadRequestErrorResponse
	JSON410      *GoneErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadVreemdelingByIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadVreemdelingByIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ReadProcessenByVreemdelingIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ProcessenResponse
	JSON400      *BadRequestErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadProcessenByVreemdelingIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadProcessenByVreemdelingIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// ReadVreemdelingByIdWithResponse request returning *ReadVreemdelingByIdResponse
func (c *ClientWithResponses) ReadVreemdelingByIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*ReadVreemdelingByIdResponse, error) {
	rsp, err := c.ReadVreemdelingById(ctx, vreemdelingId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadVreemdelingByIdResponse(rsp)
}

// ReadProcessenByVreemdelingIdWithResponse request returning *ReadProcessenByVreemdelingIdResponse
func (c *ClientWithResponses) ReadProcessenByVreemdelingIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*ReadProcessenByVreemdelingIdResponse, error) {
	rsp, err := c.ReadProcessenByVreemdelingId(ctx, vreemdelingId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadProcessenByVreemdelingIdResponse(rsp)
}

// ParseReadVreemdelingByIdResponse parses an HTTP response from a ReadVreemdelingByIdWithResponse call
func ParseReadVreemdelingByIdResponse(rsp *http.Response) (*ReadVreemdelingByIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadVreemdelingByIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest VreemdelingWithObservationsResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 410:
		var dest GoneErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON410 = &dest

	}

	return response, nil
}

// ParseReadProcessenByVreemdelingIdResponse parses an HTTP response from a ReadProcessenByVreemdelingIdWithResponse call
func ParseReadProcessenByVreemdelingIdResponse(rsp *http.Response) (*ReadProcessenByVreemdelingIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadProcessenByVreemdelingIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ProcessenResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Find observations about a vreemdeling by ID
	// (GET /vreemdelingen/{vreemdelingId})
	ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams)
	// Find processen about a vreemdling by ID
	// (GET /vreemdelingen/{vreemdelingId}/processen)
	ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Find observations about a vreemdeling by ID
// (GET /vreemdelingen/{vreemdelingId})
func (_ Unimplemented) ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Find processen about a vreemdling by ID
// (GET /vreemdelingen/{vreemdelingId}/processen)
func (_ Unimplemented) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// ReadVreemdelingById operation middleware
func (siw *ServerInterfaceWrapper) ReadVreemdelingById(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "vreemdelingId" -------------
	var vreemdelingId PathVreemdelingId

	err = runtime.BindStyledParameterWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, chi.URLParam(r, "vreemdelingId"), &vreemdelingId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "vreemdelingId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadVreemdelingByIdParams

	// ------------- Required query parameter "attributes" -------------

	if paramValue := r.URL.Query().Get("attributes"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "attributes"})
		return
	}

	err = runtime.BindQueryParameter("form", false, true, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadVreemdelingById(w, r, vreemdelingId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ReadProcessenByVreemdelingId operation middleware
func (siw *ServerInterfaceWrapper) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "vreemdelingId" -------------
	var vreemdelingId PathVreemdelingId

	err = runtime.BindStyledParameterWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, chi.URLParam(r, "vreemdelingId"), &vreemdelingId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "vreemdelingId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadProcessenByVreemdelingIdParams

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadProcessenByVreemdelingId(w, r, vreemdelingId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/vreemdelingen/{vreemdelingId}", wrapper.ReadVreemdelingById)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/vreemdelingen/{vreemdelingId}/processen", wrapper.ReadProcessenByVreemdelingId)
	})

	return r
}

type BadRequestErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type GoneErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type ProcessenResponseJSONResponse struct {
	Data []Proces `json:"data"`
}

type VreemdelingWithObservationsResponseJSONResponse struct {
	// Data A known vreemdeling, with merged attributes and full list of relevant observations.
	Data VreemdelingWithObservations `json:"data"`
}

type ReadVreemdelingByIdRequestObject struct {
	VreemdelingId PathVreemdelingId `json:"vreemdelingId"`
	Params        ReadVreemdelingByIdParams
}

type ReadVreemdelingByIdResponseObject interface {
	VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error
}

type ReadVreemdelingById200JSONResponse struct {
	VreemdelingWithObservationsResponseJSONResponse
}

func (response ReadVreemdelingById200JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type ReadVreemdelingById400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadVreemdelingById400JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ReadVreemdelingById410JSONResponse struct{ GoneErrorResponseJSONResponse }

func (response ReadVreemdelingById410JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(410)

	return json.NewEncoder(w).Encode(response)
}

type ReadProcessenByVreemdelingIdRequestObject struct {
	VreemdelingId PathVreemdelingId `json:"vreemdelingId"`
	Params        ReadProcessenByVreemdelingIdParams
}

type ReadProcessenByVreemdelingIdResponseObject interface {
	VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error
}

type ReadProcessenByVreemdelingId200JSONResponse struct{ ProcessenResponseJSONResponse }

func (response ReadProcessenByVreemdelingId200JSONResponse) VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type ReadProcessenByVreemdelingId400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadProcessenByVreemdelingId400JSONResponse) VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Find observations about a vreemdeling by ID
	// (GET /vreemdelingen/{vreemdelingId})
	ReadVreemdelingById(ctx context.Context, request ReadVreemdelingByIdRequestObject) (ReadVreemdelingByIdResponseObject, error)
	// Find processen about a vreemdling by ID
	// (GET /vreemdelingen/{vreemdelingId}/processen)
	ReadProcessenByVreemdelingId(ctx context.Context, request ReadProcessenByVreemdelingIdRequestObject) (ReadProcessenByVreemdelingIdResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHttpHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHttpMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// ReadVreemdelingById operation middleware
func (sh *strictHandler) ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams) {
	var request ReadVreemdelingByIdRequestObject

	request.VreemdelingId = vreemdelingId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadVreemdelingById(ctx, request.(ReadVreemdelingByIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadVreemdelingById")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadVreemdelingByIdResponseObject); ok {
		if err := validResponse.VisitReadVreemdelingByIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ReadProcessenByVreemdelingId operation middleware
func (sh *strictHandler) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams) {
	var request ReadProcessenByVreemdelingIdRequestObject

	request.VreemdelingId = vreemdelingId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadProcessenByVreemdelingId(ctx, request.(ReadProcessenByVreemdelingIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadProcessenByVreemdelingId")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadProcessenByVreemdelingIdResponseObject); ok {
		if err := validResponse.VisitReadProcessenByVreemdelingIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xaW3PbuBX+Kxh0H9opKVGKLwmf6jTZjDvJNM2tM7XdDkQeiliDAAOAUlWN/nsHICmC",
	"F0lM4mT9ED/sRiRwcC4fvnMOwC2ORJYLDlwrHG5xTiTJQIOsfun0kwTIYmCUL69j8zAGFUmaayo4DvH1",
	"CyQStGoGIS2QBF1IPsEehv+SLGeAQzybPzk7v7h8+izAHqZmqpGOPcxJZt6vWut4WMLngkqIcahlAR5W",
	"UQoZMQr8IiHBIf7DtFF9Wr5V07aU3c7DnwuQmyutJV0UGlTfgr+KLCO+AmO6hhgxqrSxieznGJNUKtYt",
	"g24wYZQo7GGVS4B7TRhwfGdG5EzEgMOEMAWVrVaLxthG9lFLncU6i1ANmWoNaY3wjHM1SLP0v2+I/7+7",
	"P/+CPaw3uR2pJeVLvNs/IFKSjfmt9MbKSoTMcO2896KQ0Zd47v31qzdXSJXTjPOsmAn6h/kfIozt39EE",
	"caGRyiGiCYW44+FIEAuWeKxfK7n4gBONvGHnlSs9hNN2JqAqF1yVLntO4nfwuQClX0op5LvqnXkVCa6B",
	"a/NPkueMRsQ4dvqbMt7dDpmwxWCEKBzebHEGSpFlubJAa+AaraUwOt7tPJxLkYPUtNSinua646gEx0vH",
	"9pu1qe+UnYvqm3r1u/0wsfgNIo13ZmCHT/iKMBojyvNCI1UYvxhc7Dz8SnD4vj40WExEweOvdaEr4Hfz",
	"4ItGDfTHRaGRTgFJUWhAVCtgCaIKWS//yfr1rRQRKAX8W/0aE02sU0iLbl1iCtsv3bE9CoskGFq50jjE",
	"82D+xJ/N/dmzD7PzMAjCIPiXoYYYhzgI4AJIcu7D2eUz/+xiHvtPIZ77ZxdBlFzEZBZcJpZGrM2nRJYU",
	"YuJJI00h8UtqWBFWWA7hzHAUx3cmwgNPdw+ueG7jY5JvO4kqTXShDBbyJShNpG7YivIFrIlhLKWBMTrM",
	"CmXA2oD+GbtHGbuRbFLu5ZN0YgM/hkxeVyk9rznCiHZKwn9Snf59oUCuLD+oh6GQbVVbhVssHOE9zNUV",
	"WBW0/5BW1J58mF2G5+fh2cyJWvnnD/yn+pudxBH+m0g5es/FGjs4cp9Wq7Uj3t5JP9yu+UPsj4MMcgyT",
	"R+Dy9cB8X0QGkEnBkNHHirPSqlWNUleNS7ul6xuRmWpHJEjCkipdCrBlf12NRk0HUD53eotWnfoDeXB8",
	"ALuBIq4vDjUNvVLXUd+dtbdk3rLEFMAWqoaofU0zGJJJ41OA2etqWrge+T+YIpXXWh1CKxe4wKSmJ22c",
	"WM92XdSHrddAsIf8HiQzkEuIkZVrAccbAHqI8ogVsemvTf/ksgciC1FoRHUHlF/DMLMLP5j5QenNszA4",
	"/xKGCVyAjmVM3EOq6HhpsDj5TiQ52oRRydiJ91Df2Mdf5ZEO9GqktRwzBLaylegB60MKyPYPSKdEIxFF",
	"hYQYrVPKoE7s9uAmpQrJslftYOlwo9iN3n6ka1ZnUm8vdgyuZQzZ6Pr061jdceM383oHdIP75jETu9X/",
	"BzK74/setz+sLrVDWzBs+fY75YNq4ZaLh4BcVeo9DJfP0Zrq1LTrqHVUOITNn33aI+rTDu7OkZ1bU7KO",
	"qL7aOW7cvoiBwUPLLPd9I2xkN7IXXhR2N/XkNkHZHrpIcE9sA//Z3XYW7AYPbetAupIGYto95XWHD8T7",
	"VCazdu3NqEbvlXEj7LlQOcwXrZaGxDE1rEHY2/ZJ5TBL3DzKRuXuy7Lc0ZLw8Zg0qj5sbfbT1eGRbFQn",
	"nxMYameaK6fBKEtDatMNiVKIkRaI1NXhiUOfY1gcZX//WKCnK7rnYs3dWs0rc2TVNjm3dYTHKCkY299H",
	"SWCwIqYwdNbolno/D5we44FTlwdOl5j9G+AOIQ9tDPfEoVeRffxYXnLvB7UvtkfSx8ls166ND2rhDPs+",
	"eqyOX/h/8nmRLUB2rv2PXPaPzNE72w4koj46JlFZo2SEMlOB0CVlZPGXFV9OOOszxAfTvRoCQxZrhomq",
	"i+jX4h40unp7XZKccZ9hCUMUqFIZJbY7BnRrL7UFR6+kvT97Q5emiYR70MDRrxRYzMjiFk9u+bVGEnIJ",
	"ysDPNJiZvdkuFgos69hbNyDMXwvJYnSLHW1uMVIbpSHzUKEgRouNHb4ikopCoZxIzUEqRLl9TtSGFVk1",
	"xXia0QiqU/bq5vvlx7ev0WxiNl0hjb9SrXMVTqdQ5GwCxXQ2mU+BT22qodpG6ddyU5YqmW0JUpXODCbB",
	"JLCgzIGTnOIQP5kEkydlNFO7Fd2dBny6beFmZ0YsQffx885+G6KsXX3u7jbkFe1rsfeN9aLyLMsbGTXJ",
	"t47EbKAZEJvGdCoUOKnO8ozl//3JsS383wGJnSz3fGNLNveLmJth6mmGTPtfzOy8k5O6n6iMnVJ/mGHI",
	"s/XNwTwIDtHkftx0zC3OzsNnY2Qd+sjBzJ+NmN+/2rdH+UWWEbmxSOXx0KFnGyuLDbp+YYiFLJWtipp3",
	"7eOzMrMcB/C0ufI6BWXSfDPEWHNVNhrMw1DcX8s/33zqfBv1ozD5bQDrf1fwzXDqg6LxdhsRIwBRTq2u",
	"tWxWqPzZEGg4naqUSIh9ZjjSX5DoHnjsz+aXhiEnswmn+YSK8GnwNJiuAuvZNv/aiROS52pSpbAJB70W",
	"8t6Ov9tr10XXyxXIjU7tkb81LRES6NLkhSlhFLjykJDoFrdgfItN0nhR6CidDH5cZ1U80giIBCmRgV3Y",
	"M1my3DeWpt1j1FxQrm2CohkYT7sXZ5EW0lletA7ChwzV6aYxtI5pbWD5e9iyKoi7u93/AwAA//+PcuLh",
	"yygAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
